> ## Documentation Index
> Fetch the complete documentation index at: https://docs.tokenfactory.nebius.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Complete a multipart upload, create a new dataset

> Complete a multipart upload



## OpenAPI

````yaml https://api.tokenfactory.nebius.com/openapi.json post /v1/datasets/uploads/{upload_id}/complete
openapi: 3.1.0
info:
  title: Nebius OpenAI-compatible inference API
  version: 20260506-297d05704
servers:
  - url: https://api.tokenfactory.nebius.com
security: []
paths:
  /v1/datasets/uploads/{upload_id}/complete:
    post:
      tags:
        - datasets
      summary: Complete a multipart upload, create a new dataset
      description: Complete a multipart upload
      operationId: complete_upload_v1_datasets_uploads__upload_id__complete_post
      parameters:
        - name: upload_id
          in: path
          required: true
          schema:
            type: string
            title: Upload Id
        - name: ai_project_id
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            title: Ai Project Id
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CompleteUploadRequest'
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/UploadResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - HTTPBearer: []
components:
  schemas:
    CompleteUploadRequest:
      properties:
        part_ids:
          items:
            type: string
          type: array
          title: Part Ids
      type: object
      required:
        - part_ids
      title: CompleteUploadRequest
    UploadResponse:
      properties:
        id:
          type: string
          title: Id
          description: The object identifier, which can be referenced in the API endpoints.
          examples:
            - 4d89c87498354518b92fa02fc0ad8720
        upload_info:
          allOf:
            - $ref: '#/components/schemas/UploadInfoResponse'
          description: Detailed information about the upload
      type: object
      required:
        - id
        - upload_info
      title: UploadResponse
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    UploadInfoResponse:
      properties:
        status:
          allOf:
            - $ref: '#/components/schemas/UploadStatus'
          description: Current status of the upload
          examples:
            - PENDING
            - COMPLETED
            - FAILED
        dataset:
          allOf:
            - $ref: '#/components/schemas/UploadDatasetInfoResponse'
          description: Dataset information for this upload
        error:
          anyOf:
            - type: string
            - type: 'null'
          title: Error
          description: Error message if upload failed
          examples:
            - null
        created_at:
          type: integer
          title: Created At
          description: Unix timestamp when the dataset was created.
          examples:
            - 1760109124
        completed_at:
          anyOf:
            - type: integer
            - type: 'null'
          title: Completed At
          description: Unix timestamp when the upload was completed
          examples:
            - 1760109124
        ai_project_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Ai Project Id
          description: AI Studio project ID to associate with the dataset.
          examples:
            - example_project
      type: object
      required:
        - status
        - dataset
        - created_at
      title: UploadInfoResponse
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    UploadStatus:
      type: string
      enum:
        - PENDING
        - COMPLETING
        - COMPLETED
        - FAILED
        - CANCELLED
      title: UploadStatus
    UploadDatasetInfoResponse:
      properties:
        id:
          anyOf:
            - type: string
            - type: 'null'
          title: Id
          description: Dataset ID if upload is completed
          examples:
            - 4d89c87498354518b92fa02fc0ad8720
        name:
          type: string
          title: Name
          description: ID of the dataset.
          examples:
            - example_dataset
        schema:
          items:
            $ref: '#/components/schemas/ColumnSchema-Output'
          type: array
          title: Schema
          description: Dataset schema definition.
          examples:
            - name: text
              type:
                name: string
            - name: text_1
              type:
                item:
                  name: string
                name: option
        folder:
          type: string
          title: Folder
          description: Folder path where the dataset is stored.
          examples:
            - /some/folder
      type: object
      required:
        - name
        - schema
        - folder
      title: UploadDatasetInfoResponse
    ColumnSchema-Output:
      properties:
        name:
          type: string
          title: Name
        type:
          anyOf:
            - $ref: '#/components/schemas/SchemaPrimitive'
            - $ref: '#/components/schemas/SchemaOption-Output'
          title: Type
      type: object
      required:
        - name
        - type
      title: ColumnSchema
    SchemaPrimitive:
      properties:
        name:
          $ref: '#/components/schemas/SchemaPrimitiveType'
      type: object
      required:
        - name
      title: SchemaPrimitive
    SchemaOption-Output:
      properties:
        name:
          $ref: '#/components/schemas/SchemaOptionType'
        item:
          anyOf:
            - $ref: '#/components/schemas/SchemaPrimitive'
            - $ref: '#/components/schemas/SchemaOption-Output'
          title: Item
      type: object
      required:
        - name
        - item
      title: SchemaOption
    SchemaPrimitiveType:
      type: string
      enum:
        - string
        - integer
        - boolean
        - float
        - double
        - json
        - 'null'
      title: SchemaPrimitiveType
    SchemaOptionType:
      type: string
      enum:
        - option
      const: option
      title: SchemaOptionType
  securitySchemes:
    HTTPBearer:
      type: http
      scheme: bearer

````